You can customize the validator’s title, input message, error message, and so on. With these settings you will know what data can or should be entered in a cell, and when the data is invalid you will get a message.
When you use the validator object, you can set its properties. For example:
When you input invalid data, the control will trigger the ValidationError event. For example:
var spreadNS = GC.Spread.Sheets;
window.onload = function () {
var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), {sheetCount: 2});
initSpread(spread);
};
function initSpread(spread) {
var self = this;
var sheet = spread.getSheet(0);
spread.options.highlightInvalidData = true;
var validatorTypes = "DateValidator";
_getElementById("validatorTab2").style.display = 'none';
_getElementById("validatorTab3").style.display = 'none';
_getElementById("isIntTab").style.display = 'none';
_getElementById("dogear-position").style.display = 'none';
_getElementById("icon-position").style.display = 'none';
_getElementById("iconFile").style.display = 'none';
var updateValidatorTab = function (validatorTypes) {
switch (validatorTypes) {
case "DateValidator":
_getElementById("validatorTab1").style.display = 'block';
_getElementById("isIntTab").style.display = 'none';
_getElementById("validatorTab2").style.display = 'none';
_getElementById("validatorTab3").style.display = 'none';
break;
case "ListValidator":
_getElementById("validatorTab3").style.display = 'block';
_getElementById("validatorTab2").style.display = 'none';
_getElementById("validatorTab1").style.display = 'none';
break;
case "FormulaListValidator":
case "FormulaValidator":
_getElementById("validatorTab2").style.display = 'block';
_getElementById("validatorTab1").style.display = 'none';
_getElementById("validatorTab3").style.display = 'none';
break;
case "NumberValidator":
_getElementById("validatorTab1").style.display = 'block';
_getElementById("isIntTab").style.display = 'block';
_getElementById("validatorTab2").style.display = 'none';
_getElementById("validatorTab3").style.display = 'none';
break;
case "TextLengthValidator":
_getElementById("validatorTab1").style.display = 'block';
_getElementById("isIntTab").style.display = 'none';
_getElementById("validatorTab2").style.display = 'none';
_getElementById("validatorTab3").style.display = 'none';
break;
}
};
_getElementById("highlighticon").addEventListener("change", function () {
var file = this.files[0];
var reader = new FileReader();
if(file){
reader.readAsDataURL(file);
reader.onloadend = function (e) {
self.imageBase64 = this.result;
};
}
});
_getElementById("highlightType").addEventListener('change',function () {
switch(this.value){
case 'circle':{
_getElementById("dogear-position").style.display = 'none';
_getElementById("icon-position").style.display = 'none';
_getElementById("iconFile").style.display = 'none';
break;
}
case 'dogear':{
_getElementById("dogear-position").style.display = '';
_getElementById("icon-position").style.display = 'none';
_getElementById("iconFile").style.display = 'none';
break;
}
case 'icon':{
_getElementById("dogear-position").style.display = 'none';
_getElementById("icon-position").style.display = '';
_getElementById("iconFile").style.display = '';
break;
}
}
});
_getElementById("validatorTypes").addEventListener('change',function () {
validatorTypes = this.value;
updateValidatorTab(validatorTypes);
});
_getElementById("validatorComparisonOperator").addEventListener('change',function () {
var operatorType = this.value;
switch (operatorType) {
case '6':
case '7':
_getElementById("txtValidatorValue2").style.display = 'block';
break;
default:
_getElementById("txtValidatorValue2").style.display = 'none';
break;
}
});
_getElementById("btnSetValidator").addEventListener('click',function () {
var gcdv = spreadNS.DataValidation;
var ddv = null;
var v1 = _getElementById("txtValidatorValue1").value;
var v2 = _getElementById("txtValidatorValue2").value;
switch (validatorTypes) {
case "DateValidator":
ddv = gcdv.createDateValidator(parseInt(_getElementById("validatorComparisonOperator").value), new Date(v1), new Date(v2));
break;
case "FormulaListValidator":
ddv = gcdv.createFormulaListValidator(_getElementById("txtValidatorValue").value);
break;
case "FormulaValidator":
ddv = gcdv.createFormulaValidator(_getElementById("txtValidatorValue").value);
break;
case "ListValidator":
ddv = gcdv.createListValidator(_getElementById("txtListValidatorValue").value);
ddv.inCellDropdown(_getElementById("ckbIncellDropDown").checked);
break;
case "NumberValidator":
if (_getElementById("chkIsInteger").checked) {
ddv = gcdv.createNumberValidator(parseInt(_getElementById("validatorComparisonOperator").value),
isNaN(v1) ? v1 : parseInt(v1),
isNaN(v2) ? v2 : parseInt(v2),
true);
} else {
ddv = gcdv.createNumberValidator(parseInt(_getElementById("validatorComparisonOperator").value),
isNaN(v1) ? v1 : parseFloat(v1),
isNaN(v2) ? v2 : parseFloat(v2),
false);
}
break;
case "TextLengthValidator":
ddv = gcdv.createTextLengthValidator(parseInt(_getElementById("validatorComparisonOperator").value),
isNaN(v1) ? v1 : parseInt(v1),
isNaN(v2) ? v2 : parseInt(v2));
break;
}
if (ddv != null) {
ddv.errorMessage(_getElementById("txtErrorMessage").value);
ddv.errorStyle(parseInt(_getElementById("validatorErrorStyles").value));
ddv.errorTitle(_getElementById("txtErrorTitle").value);
ddv.showErrorMessage(_getElementById("chkShowError").checked);
ddv.ignoreBlank(_getElementById("chkValidatorIgnoreBlank").checked);
ddv.showInputMessage(_getElementById("ckbShowInputMessage").checked);
ddv.inputTitle(_getElementById("txtInputTitle").value);
ddv.inputMessage(_getElementById("txtInputMessage").value);
var highLightStyle = _getElementById("highlightType").value;
var dogearPosition = _getElementById("dogearPositionOption").value;
var iconPosition = _getElementById("iconPositionOption").value;
var highlightStyleColor = _getElementById("highlightColor").value;
if (highLightStyle === "circle") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.circle,
color: highlightStyleColor
});
} else if (highLightStyle === "dogear" && dogearPosition === "Top Left") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.topLeft
});
} else if (highLightStyle === "dogear" && dogearPosition === "Top Right") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.topRight
});
} else if (highLightStyle === "dogear" && dogearPosition === "Bottom Left") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.bottomLeft
});
} else if (highLightStyle === "dogear" && dogearPosition === "Bottom Right") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.bottomRight
});
} else if (highLightStyle === "icon" && iconPosition === "Outside Left") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.icon,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.outsideLeft,
image: self.imageBase64
});
} else if (highLightStyle === "icon" && iconPosition === "Outside Right") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.icon,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.outsideRight,
image: self.imageBase64
});
}
var ss = GC.Spread.Sheets.findControl(document.getElementById('ss'));
var sheet = ss.getActiveSheet();
sheet.suspendPaint();
var sels = sheet.getSelections();
for (var i = 0; i < sels.length; i++) {
var sel = getActualRange(sheet, sels[i]);
sheet.setDataValidator(sel.row, sel.col, sel.rowCount, sel.colCount, ddv);
}
sheet.resumePaint();
}
});
_getElementById("chkValidatorIgnoreBlank").addEventListener('change',function () {
var ss = GC.Spread.Sheets.findControl(document.getElementById('ss'));
var sheet = ss.getActiveSheet();
var sels = sheet.getSelections();
for (var i = 0; i < sels.length; i++) {
var sel = getActualRange(sheet, sels[i]);
for (var r = 0; r < sel.rowCount; r++) {
for (var c = 0; c < sel.colCount; c++) {
var dv = sheet.getDataValidator(sel.row + r, sel.col + c);
if (dv) {
dv.ignoreBlank(this.checked);
}
}
}
}
});
_getElementById("chkShowError").addEventListener('change',function () {
var ss = GC.Spread.Sheets.findControl(document.getElementById('ss'));
var sheet = ss.getActiveSheet();
var checked = _getElementById("chkShowError").checked;
if (checked) {
ss.bind(spreadNS.Events.ValidationError, function (event, data) {
var dv = data.validator;
if (dv) {
alert(dv.errorMessage());
}
});
} else {
ss.unbind(spreadNS.Events.ValidationError);
}
});
_getElementById("btnClearValidator").addEventListener('click',function () {
var sheet = spread.getActiveSheet();
var sels = sheet.getSelections();
for (var i = 0; i < sels.length; i++) {
var sel = getActualRange(sheet, sels[i]);
sheet.setDataValidator(sel.row, sel.col, sel.rowCount, sel.colCount, null);
}
});
spread.bind(GC.Spread.Sheets.Events.EnterCell, function (e, args) {
var sheet = spread.getActiveSheet();
var activeRow = sheet.getActiveRowIndex();
var activeCol = sheet.getActiveColumnIndex();
var dataValidator = sheet.getDataValidator(activeRow, activeCol);
var validatorTypes = _getElementById("validatorTypes");
if (dataValidator) {
var type = dataValidator.type();
switch (type) {
case 1:
case 2:
validatorTypes = "NumberValidator";
break;
case 3:
var condition = dataValidator.condition();
if (condition && condition.formula()) {
validatorTypes = "FormulaListValidator";
} else {
validatorTypes = "ListValidator";
}
break;
case 4:
validatorTypes = "DateValidator";
break;
case 6:
validatorTypes = "TextLengthValidator";
break;
case 7:
validatorTypes = "FormulaValidator";
break;
}
validatorTypes.value = validatorTypes;
updateValidatorTab(validatorTypes);
_getElementById("validatorComparisonOperator").value = dataValidator.comparisonOperator();
_getElementById("txtValidatorValue1").value = dataValidator.value1();
_getElementById("txtValidatorValue2").value = dataValidator.value2();
_getElementById("txtValidatorValue").value = dataValidator.value1();
_getElementById("txtListValidatorValue").value = dataValidator.value1();
_getElementById("chkIsInteger").setAttribute('checked', type === 1);
_getElementById("ckbShowInputMessage").setAttribute('checked', dataValidator.showInputMessage());
_getElementById("txtInputTitle").value = dataValidator.inputTitle();
_getElementById("txtInputMessage").value = dataValidator.inputMessage();
_getElementById("chkShowError").setAttribute('checked', dataValidator.showErrorMessage());
_getElementById("chkValidatorIgnoreBlank").setAttribute('checked', dataValidator.ignoreBlank());
_getElementById("txtErrorTitle").value = dataValidator.errorTitle();
_getElementById("txtErrorMessage").value = dataValidator.errorMessage();
_getElementById("validatorErrorStyles").value = dataValidator.errorStyle();
}
});
}
function getActualRange(sheet, range) {
var row = range.row, rowCount = range.rowCount;
if (row === -1) {
row = 0;
rowCount = sheet.getRowCount();
}
var col = range.col, colCount = range.colCount;
if (col === -1) {
col = 0;
colCount = sheet.getColumnCount();
}
return new GC.Spread.Sheets.Range(row, col, rowCount, colCount);
}
function _getElementById(id){
return document.getElementById(id);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<p>
Select a cell or range of cells in the sheet then use the options below to create a data validator for that cell(s). You can also set the input message that displays when the user tries to edit the cell(s) as well as the error message that shows if the input does not fit the conditions.
</p>
<div class="option-row">
<select id="validatorTypes">
<option value="DateValidator" selected>DateValidator</option>
<option value="FormulaListValidator">FormulaListValidator</option>
<option value="FormulaValidator">FormulaValidator</option>
<option value="ListValidator">ListValidator</option>
<option value="NumberValidator">NumberValidator</option>
<option value="TextLengthValidator">TextLengthValidator</option>
</select>
</div>
<div id="validatorTab1">
<div class="option-row">
<select id="validatorComparisonOperator">
<option value="6" selected>Between</option>
<option value="7">NotBetween</option>
<option value="0">EqualTo</option>
<option value="1">NotEqualTo</option>
<option value="2">GreaterThan</option>
<option value="4">LessThan</option>
<option value="3">GreaterThanOrEqualTo</option>
<option value="5">LessThanOrEqualTo</option>
</select>
</div>
<div class="option-row">
<input class="normal-input" id="txtValidatorValue1" type="text" placeholder="Value1"/>
</div>
<div class="option-row">
<input class="normal-input" id="txtValidatorValue2" type="text" placeholder="Value2"/>
</div>
<div class="option-row" id="isIntTab">
<input class="normal-input" id="chkIsInteger" type="checkbox"/><label for="chkIsInteger">Is Integer</label>
</div>
</div>
<div class="option-row" id="validatorTab2">
<input class="normal-input" type="text" id="txtValidatorValue" placeholder="Value1" />
</div>
<div class="option-row" id="validatorTab3">
<input class="normal-input" type="text" id="txtListValidatorValue" placeholder="(eg:1,2,3,4,5)" />
<input class="normal-input" type="checkbox" id="ckbIncellDropDown" checked="checked" />
<label for="ckbIncellDropDown">Show In-Cell DropDown</label>
</div>
<div class="option-row">
<input class="normal-input" type="checkbox" checked="checked" id="ckbShowInputMessage" />
<label for="ckbShowInputMessage">Show InputMessage</label>
</div>
<div class="option-row">
<label>Title:</label>
<input class="normal-input" type="text" id="txtInputTitle" placeholder="Title"/>
</div>
<div class="option-row">
<label>Input Message:</label>
<input class="normal-input" type="text" id="txtInputMessage" placeholder="Input Message"/>
</div>
<div class="option-row">
<input class="normal-input" id="chkShowError" type="checkbox" />
<label for="chkShowError">ShowErrorMessage</label>
</div>
<div class="option-row">
<input class="normal-input" id="chkValidatorIgnoreBlank" type="checkbox" />
<label for="chkValidatorIgnoreBlank">IgnoreBlank</label>
</div>
<div class="option-row">
<input class="normal-input" id="txtErrorTitle" type="text" placeholder="ErrorTitle"/>
</div>
<div class="option-row">
<input class="normal-input" id="txtErrorMessage" type="text" placeholder="ErrorMessage"/>
</div>
<div class="option-row">
<select id="validatorErrorStyles">
<option value="0" selected>Stop</option>
<option value="1">Warning</option>
<option value="2">Information</option>
</select>
</div>
<div class="option-row">
<label>Custom HighlightStyle:</label>
<select id="highlightType">
<option selected="selected" value="circle" data-bind="text: res.dataValidationDialog.circle">
Circle
</option>
<option value="dogear" data-bind="text: res.dataValidationDialog.dogear">
Dogear
</option>
<option value="icon" data-bind="text: res.dataValidationDialog.icon">
Icon
</option>
</select>
</div>
<div class="option-row">
<input class="normal-input" id="highlightColor" type="text" placeholder="HighlightColor"/>
</div>
<div id="dogear-position" class="option-row">
<label>Dogear Position:</label>
<select id="dogearPositionOption">
<option value="Top Left" data-bind="text: res.dataValidationDialog.topLeft">
Top Left
</option>
<option value="Top Right" data-bind="text: res.dataValidationDialog.topRight">
Top Right
</option>
<option value="Bottom Right" data-bind="text: res.dataValidationDialog.bottomRight">
Bottom Right
</option>
<option value="Bottom Left" data-bind="text: res.dataValidationDialog.bottomLeft">
Bottom Left
</option>
</select>
</div>
<div id="icon-position" class="option-row">
<label>Icon Position:</label>
<select id="iconPositionOption">
<option value="Outside Left" data-bind="text: res.dataValidationDialog.outsideLeft">
Outside Left
</option>
<option value="Outside Right" data-bind="text: res.dataValidationDialog.outsideRight">
Outside Right
</option>
</select>
</div>
<div id="iconFile" class = "option-row">
<input id="highlighticon" type="file" accept="image/*">
</div>
<div class = "option-row">
<input class="normal-input" id="btnSetValidator" type="button" value="Set Validator" />
</div>
<div class = "option-row">
<input class="normal-input" id="btnClearValidator" type="button" value="Clear Validator" />
</div>
</div>
</div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 5px;
}
.normal-input {
display: block;
padding: 4px 6px;
box-sizing: border-box;
width: 100%;
}
select {
display: block;
padding: 4px 6px;
box-sizing: border-box;
width: 100%;
}
input[type = checkbox] {
display: inline-block;
width: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

You can customize the validator’s title, input message, error message, and so on. With these settings you will know what data can or should be entered in a cell, and when the data is invalid you will get a message.
When you use the validator object, you can set its properties. For example:
When you input invalid data, the control will trigger the ValidationError event. For example:
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
function _getElementById(id) {
return document.getElementById(id);
}
export function AppFunc() {
let spread = null;
let imageBase64 = "";
const initSpread = (currSpread) => {
spread = currSpread;
spread.suspendPaint();
spread.options.highlightInvalidData = true;
_getElementById("validatorTab2").style.display = 'none';
_getElementById("validatorTab3").style.display = 'none';
_getElementById("isIntTab").style.display = 'none';
_getElementById("dogear-position").style.display = 'none';
_getElementById("icon-position").style.display = 'none';
_getElementById("iconFile").style.display = 'none';
spread.bind(GC.Spread.Sheets.Events.EnterCell, function (e, args) {
let sheet = spread.getActiveSheet();
let activeRow = sheet.getActiveRowIndex();
let activeCol = sheet.getActiveColumnIndex();
let dataValidator = sheet.getDataValidator(activeRow, activeCol);
let validatorTypesElement = _getElementById("validatorTypes"), validatorTypes;
if (dataValidator) {
let type = dataValidator.type();
switch (type) {
case 1:
case 2:
validatorTypes = "NumberValidator";
break;
case 3:
let condition = dataValidator.condition();
if (condition && condition.formula()) {
validatorTypes = "FormulaListValidator";
} else {
validatorTypes = "ListValidator";
}
break;
case 4:
validatorTypes = "DateValidator";
break;
case 6:
validatorTypes = "TextLengthValidator";
break;
case 7:
validatorTypes = "FormulaValidator";
break;
}
validatorTypesElement.value = validatorTypes;
updateValidatorTab(validatorTypes);
_getElementById("validatorComparisonOperator").value = dataValidator.comparisonOperator();
_getElementById("txtValidatorValue1").value = dataValidator.value1();
_getElementById("txtValidatorValue2").value = dataValidator.value2();
_getElementById("txtValidatorValue").value = dataValidator.value1();
_getElementById("txtListValidatorValue").value = dataValidator.value1();
_getElementById("chkIsInteger").setAttribute('checked', type === 1);
_getElementById("ckbShowInputMessage").setAttribute('checked', dataValidator.showInputMessage());
_getElementById("txtInputTitle").value = dataValidator.inputTitle();
_getElementById("txtInputMessage").value = dataValidator.inputMessage();
_getElementById("chkShowError").setAttribute('checked', dataValidator.showErrorMessage());
_getElementById("chkValidatorIgnoreBlank").setAttribute('checked', dataValidator.ignoreBlank());
_getElementById("txtErrorTitle").value = dataValidator.errorTitle();
_getElementById("txtErrorMessage").value = dataValidator.errorMessage();
_getElementById("validatorErrorStyles").value = dataValidator.errorStyle();
}
});
spread.resumePaint();
}
const changeHighlighticon = (e) => {
let file = e.target.files[0];
let reader = new FileReader();
if (file) {
reader.readAsDataURL(file);
reader.onloadend = function (e) {
imageBase64 = this.result;
};
}
}
const changeHighlightType = (e) => {
switch (e.target.value) {
case 'circle': {
_getElementById("dogear-position").style.display = 'none';
_getElementById("icon-position").style.display = 'none';
_getElementById("iconFile").style.display = 'none';
break;
}
case 'dogear': {
_getElementById("dogear-position").style.display = '';
_getElementById("icon-position").style.display = 'none';
_getElementById("iconFile").style.display = 'none';
break;
}
case 'icon': {
_getElementById("dogear-position").style.display = 'none';
_getElementById("icon-position").style.display = '';
_getElementById("iconFile").style.display = '';
break;
}
}
}
const changeValidatorTypes = (e) => {
let validatorTypes = e.target.value;
updateValidatorTab(validatorTypes);
}
const updateValidatorTab = (validatorTypes) => {
switch (validatorTypes) {
case "DateValidator":
case "TextLengthValidator":
_getElementById("validatorTab1").style.display = 'block';
_getElementById("isIntTab").style.display = 'none';
_getElementById("validatorTab2").style.display = 'none';
_getElementById("validatorTab3").style.display = 'none';
break;
case "ListValidator":
_getElementById("validatorTab3").style.display = 'block';
_getElementById("validatorTab2").style.display = 'none';
_getElementById("validatorTab1").style.display = 'none';
break;
case "FormulaListValidator":
case "FormulaValidator":
_getElementById("validatorTab2").style.display = 'block';
_getElementById("validatorTab1").style.display = 'none';
_getElementById("validatorTab3").style.display = 'none';
break;
case "NumberValidator":
_getElementById("validatorTab1").style.display = 'block';
_getElementById("isIntTab").style.display = 'block';
_getElementById("validatorTab2").style.display = 'none';
_getElementById("validatorTab3").style.display = 'none';
break;
}
}
const changeValidatorComparisonOperator = (e) => {
let operatorType = e.target.value;
switch (operatorType) {
case '6':
case '7':
_getElementById("txtValidatorValue2").style.display = 'block';
break;
default:
_getElementById("txtValidatorValue2").style.display = 'none';
break;
}
}
const setValidator = (e) => {
let gcdv = GC.Spread.Sheets.DataValidation;
let ddv = null;
let v1 = _getElementById("txtValidatorValue1").value;
let v2 = _getElementById("txtValidatorValue2").value;
let validatorTypes = _getElementById("validatorTypes").value;
switch (validatorTypes) {
case "DateValidator":
ddv = gcdv.createDateValidator(parseInt(_getElementById("validatorComparisonOperator").value), new Date(v1), new Date(v2));
break;
case "FormulaListValidator":
ddv = gcdv.createFormulaListValidator(_getElementById("txtValidatorValue").value);
break;
case "FormulaValidator":
ddv = gcdv.createFormulaValidator(_getElementById("txtValidatorValue").value);
break;
case "ListValidator":
ddv = gcdv.createListValidator(_getElementById("txtListValidatorValue").value);
ddv.inCellDropdown(_getElementById("ckbIncellDropDown").checked);
break;
case "NumberValidator":
if (_getElementById("chkIsInteger").checked) {
ddv = gcdv.createNumberValidator(parseInt(_getElementById("validatorComparisonOperator").value),
isNaN(v1) ? v1 : parseInt(v1),
isNaN(v2) ? v2 : parseInt(v2),
true);
} else {
ddv = gcdv.createNumberValidator(parseInt(_getElementById("validatorComparisonOperator").value),
isNaN(v1) ? v1 : parseFloat(v1),
isNaN(v2) ? v2 : parseFloat(v2),
false);
}
break;
case "TextLengthValidator":
ddv = gcdv.createTextLengthValidator(parseInt(_getElementById("validatorComparisonOperator").value),
isNaN(v1) ? v1 : parseInt(v1),
isNaN(v2) ? v2 : parseInt(v2));
break;
}
if (ddv != null) {
ddv.errorMessage(_getElementById("txtErrorMessage").value);
ddv.errorStyle(parseInt(_getElementById("validatorErrorStyles").value));
ddv.errorTitle(_getElementById("txtErrorTitle").value);
ddv.showErrorMessage(_getElementById("chkShowError").checked);
ddv.ignoreBlank(_getElementById("chkValidatorIgnoreBlank").checked);
ddv.showInputMessage(_getElementById("ckbShowInputMessage").checked);
ddv.inputTitle(_getElementById("txtInputTitle").value);
ddv.inputMessage(_getElementById("txtInputMessage").value);
let highLightStyle = _getElementById("highlightType").value;
let dogearPosition = _getElementById("dogearPositionOption").value;
let iconPosition = _getElementById("iconPositionOption").value;
let highlightStyleColor = _getElementById("highlightColor").value;
if (highLightStyle === "circle") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.circle,
color: highlightStyleColor
});
} else if (highLightStyle === "dogear" && dogearPosition === "Top Left") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.topLeft
});
} else if (highLightStyle === "dogear" && dogearPosition === "Top Right") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.topRight
});
} else if (highLightStyle === "dogear" && dogearPosition === "Bottom Left") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.bottomLeft
});
} else if (highLightStyle === "dogear" && dogearPosition === "Bottom Right") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.bottomRight
});
} else if (highLightStyle === "icon" && iconPosition === "Outside Left") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.icon,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.outsideLeft,
image: imageBase64
});
} else if (highLightStyle === "icon" && iconPosition === "Outside Right") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.icon,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.outsideRight,
image: imageBase64
});
}
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
let sels = sheet.getSelections();
for (let i = 0; i < sels.length; i++) {
let sel = getActualRange(sheet, sels[i]);
sheet.setDataValidator(sel.row, sel.col, sel.rowCount, sel.colCount, ddv);
}
sheet.resumePaint();
}
}
const changeValidatorIgnoreBlank = (e) => {
let ss = spread;
let sheet = ss.getActiveSheet();
let sels = sheet.getSelections();
for (let i = 0; i < sels.length; i++) {
let sel = getActualRange(sheet, sels[i]);
for (let r = 0; r < sel.rowCount; r++) {
for (let c = 0; c < sel.colCount; c++) {
let dv = sheet.getDataValidator(sel.row + r, sel.col + c);
if (dv) {
dv.ignoreBlank(e.target.checked);
}
}
}
}
}
const getActualRange = (sheet, range) => {
let row = range.row, rowCount = range.rowCount;
if (row === -1) {
row = 0;
rowCount = sheet.getRowCount();
}
let col = range.col, colCount = range.colCount;
if (col === -1) {
col = 0;
colCount = sheet.getColumnCount();
}
return new GC.Spread.Sheets.Range(row, col, rowCount, colCount);
}
const clearValidator = (e) => {
let sheet = spread.getActiveSheet();
let sels = sheet.getSelections();
for (let i = 0; i < sels.length; i++) {
let sel = getActualRange(sheet, sels[i]);
sheet.setDataValidator(sel.row, sel.col, sel.rowCount, sel.colCount, null);
}
}
const changeShowError = (e) => {
let ss = spread;
let checked = e.target.checked;
if (checked) {
ss.bind(GC.Spread.Sheets.Events.ValidationError, function (event, data) {
let dv = data.validator;
if (dv) {
alert(dv.errorMessage());
}
});
} else {
ss.unbind(GC.Spread.Sheets.Events.ValidationError);
}
}
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={initSpread}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<div className="options-container">
<p>
Select a cell or range of cells in the sheet then use the options below to create a data validator for that cell(s). You can also set the input message that displays when the user tries to edit the cell(s) as well as the error message that shows if the input does not fit the conditions.
</p>
<div className="option-row">
<select id="validatorTypes" onChange={e => changeValidatorTypes(e)}>
<option value="DateValidator" selected>DateValidator</option>
<option value="FormulaListValidator">FormulaListValidator</option>
<option value="FormulaValidator">FormulaValidator</option>
<option value="ListValidator">ListValidator</option>
<option value="NumberValidator">NumberValidator</option>
<option value="TextLengthValidator">TextLengthValidator</option>
</select>
</div>
<div id="validatorTab1">
<div className="option-row">
<select id="validatorComparisonOperator" onChange={e => changeValidatorComparisonOperator(e)}>
<option value={6} selected>Between</option>
<option value={7}>NotBetween</option>
<option value={0}>EqualTo</option>
<option value={1}>NotEqualTo</option>
<option value={2}>GreaterThan</option>
<option value={4}>LessThan</option>
<option value={3}>GreaterThanOrEqualTo</option>
<option value={5}>LessThanOrEqualTo</option>
</select>
</div>
<div className="option-row">
<input className="normal-input" id="txtValidatorValue1" type="text" placeholder="Value1" />
</div>
<div className="option-row">
<input className="normal-input" id="txtValidatorValue2" type="text" placeholder="Value2" />
</div>
<div className="option-row" id="isIntTab">
<input className="normal-input" id="chkIsInteger" type="checkbox" /><label htmlFor="chkIsInteger">Is Integer</label>
</div>
</div>
<div className="option-row" id="validatorTab2">
<input className="normal-input" type="text" id="txtValidatorValue" placeholder="Value1" />
</div>
<div className="option-row" id="validatorTab3">
<input className="normal-input" type="text" id="txtListValidatorValue" placeholder="(eg:1,2,3,4,5)" />
<input className="normal-input" type="checkbox" id="ckbIncellDropDown" defaultChecked="checked" />
<label htmlFor="ckbIncellDropDown">Show In-Cell DropDown</label>
</div>
<div className="option-row">
<input className="normal-input" type="checkbox" defaultChecked="checked" id="ckbShowInputMessage" />
<label htmlFor="ckbShowInputMessage">Show InputMessage</label>
</div>
<div className="option-row">
<label>Title:</label>
<input className="normal-input" type="text" id="txtInputTitle" placeholder="Title" />
</div>
<div className="option-row">
<label>Input Message:</label>
<input className="normal-input" type="text" id="txtInputMessage" placeholder="Input Message" />
</div>
<div className="option-row">
<input className="normal-input" id="chkShowError" type="checkbox" onChange={e => changeShowError(e)} />
<label htmlFor="chkShowError">ShowErrorMessage</label>
</div>
<div className="option-row">
<input className="normal-input" id="chkValidatorIgnoreBlank" type="checkbox" onChange={e => changeValidatorIgnoreBlank(e)} />
<label htmlFor="chkValidatorIgnoreBlank">IgnoreBlank</label>
</div>
<div className="option-row">
<input className="normal-input" id="txtErrorTitle" type="text" placeholder="ErrorTitle" />
</div>
<div className="option-row">
<input className="normal-input" id="txtErrorMessage" type="text" placeholder="ErrorMessage" />
</div>
<div className="option-row">
<select id="validatorErrorStyles">
<option value={0} selected>Stop</option>
<option value={1}>Warning</option>
<option value={2}>Information</option>
</select>
</div>
<div className="option-row">
<label>Custom HighlightStyle:</label>
<select id="highlightType" onChange={e => changeHighlightType(e)}>
<option selected="selected" value="circle" data-bind="text: res.dataValidationDialog.circle">
Circle
</option>
<option value="dogear" data-bind="text: res.dataValidationDialog.dogear">
Dogear
</option>
<option value="icon" data-bind="text: res.dataValidationDialog.icon">
Icon
</option>
</select>
</div>
<div className="option-row">
<input className="normal-input" id="highlightColor" type="text" placeholder="HighlightColor" />
</div>
<div id="dogear-position" className="option-row">
<label>Dogear Position:</label>
<select id="dogearPositionOption">
<option value="Top Left" data-bind="text: res.dataValidationDialog.topLeft">
Top Left
</option>
<option value="Top Right" data-bind="text: res.dataValidationDialog.topRight">
Top Right
</option>
<option value="Bottom Right" data-bind="text: res.dataValidationDialog.bottomRight">
Bottom Right
</option>
<option value="Bottom Left" data-bind="text: res.dataValidationDialog.bottomLeft">
Bottom Left
</option>
</select>
</div>
<div id="icon-position" className="option-row">
<label>Icon Position:</label>
<select id="iconPositionOption">
<option value="Outside Left" data-bind="text: res.dataValidationDialog.outsideLeft">
Outside Left
</option>
<option value="Outside Right" data-bind="text: res.dataValidationDialog.outsideRight">
Outside Right
</option>
</select>
</div>
<div id="iconFile" className="option-row">
<input id="highlighticon" type="file" accept="image/*" onChange={e => changeHighlighticon(e)} />
</div>
<div className="option-row">
<input className="normal-input" id="btnSetValidator" type="button" defaultValue="Set Validator" onClick={e=>setValidator(e)} />
</div>
<div className="option-row">
<input className="normal-input" id="btnClearValidator" type="button" defaultValue="Clear Validator" onClick={e => clearValidator(e)} />
</div>
</div>
</div>;
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
const Component = React.Component;
function _getElementById(id) {
return document.getElementById(id);
}
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.imageBase64 = "";
}
render() {
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<div className="options-container">
<p>
Select a cell or range of cells in the sheet then use the options below to create a data validator for that cell(s). You can also set the input message that displays when the user tries to edit the cell(s) as well as the error message that shows if the input does not fit the conditions.
</p>
<div className="option-row">
<select id="validatorTypes" onChange={e => this.changeValidatorTypes(e)}>
<option value="DateValidator" selected>DateValidator</option>
<option value="FormulaListValidator">FormulaListValidator</option>
<option value="FormulaValidator">FormulaValidator</option>
<option value="ListValidator">ListValidator</option>
<option value="NumberValidator">NumberValidator</option>
<option value="TextLengthValidator">TextLengthValidator</option>
</select>
</div>
<div id="validatorTab1">
<div className="option-row">
<select id="validatorComparisonOperator" onChange={e => this.changeValidatorComparisonOperator(e)}>
<option value={6} selected>Between</option>
<option value={7}>NotBetween</option>
<option value={0}>EqualTo</option>
<option value={1}>NotEqualTo</option>
<option value={2}>GreaterThan</option>
<option value={4}>LessThan</option>
<option value={3}>GreaterThanOrEqualTo</option>
<option value={5}>LessThanOrEqualTo</option>
</select>
</div>
<div className="option-row">
<input className="normal-input" id="txtValidatorValue1" type="text" placeholder="Value1" />
</div>
<div className="option-row">
<input className="normal-input" id="txtValidatorValue2" type="text" placeholder="Value2" />
</div>
<div className="option-row" id="isIntTab">
<input className="normal-input" id="chkIsInteger" type="checkbox" /><label htmlFor="chkIsInteger">Is Integer</label>
</div>
</div>
<div className="option-row" id="validatorTab2">
<input className="normal-input" type="text" id="txtValidatorValue" placeholder="Value1" />
</div>
<div className="option-row" id="validatorTab3">
<input className="normal-input" type="text" id="txtListValidatorValue" placeholder="(eg:1,2,3,4,5)" />
<input className="normal-input" type="checkbox" id="ckbIncellDropDown" defaultChecked="checked" />
<label htmlFor="ckbIncellDropDown">Show In-Cell DropDown</label>
</div>
<div className="option-row">
<input className="normal-input" type="checkbox" defaultChecked="checked" id="ckbShowInputMessage" />
<label htmlFor="ckbShowInputMessage">Show InputMessage</label>
</div>
<div className="option-row">
<label>Title:</label>
<input className="normal-input" type="text" id="txtInputTitle" placeholder="Title" />
</div>
<div className="option-row">
<label>Input Message:</label>
<input className="normal-input" type="text" id="txtInputMessage" placeholder="Input Message" />
</div>
<div className="option-row">
<input className="normal-input" id="chkShowError" type="checkbox" onChange={e => this.changeShowError(e)} />
<label htmlFor="chkShowError">ShowErrorMessage</label>
</div>
<div className="option-row">
<input className="normal-input" id="chkValidatorIgnoreBlank" type="checkbox" onChange={e => this.changeValidatorIgnoreBlank(e)} />
<label htmlFor="chkValidatorIgnoreBlank">IgnoreBlank</label>
</div>
<div className="option-row">
<input className="normal-input" id="txtErrorTitle" type="text" placeholder="ErrorTitle" />
</div>
<div className="option-row">
<input className="normal-input" id="txtErrorMessage" type="text" placeholder="ErrorMessage" />
</div>
<div className="option-row">
<select id="validatorErrorStyles">
<option value={0} selected>Stop</option>
<option value={1}>Warning</option>
<option value={2}>Information</option>
</select>
</div>
<div className="option-row">
<label>Custom HighlightStyle:</label>
<select id="highlightType" onChange={e => this.changeHighlightType(e)}>
<option selected="selected" value="circle" data-bind="text: res.dataValidationDialog.circle">
Circle
</option>
<option value="dogear" data-bind="text: res.dataValidationDialog.dogear">
Dogear
</option>
<option value="icon" data-bind="text: res.dataValidationDialog.icon">
Icon
</option>
</select>
</div>
<div className="option-row">
<input className="normal-input" id="highlightColor" type="text" placeholder="HighlightColor" />
</div>
<div id="dogear-position" className="option-row">
<label>Dogear Position:</label>
<select id="dogearPositionOption">
<option value="Top Left" data-bind="text: res.dataValidationDialog.topLeft">
Top Left
</option>
<option value="Top Right" data-bind="text: res.dataValidationDialog.topRight">
Top Right
</option>
<option value="Bottom Right" data-bind="text: res.dataValidationDialog.bottomRight">
Bottom Right
</option>
<option value="Bottom Left" data-bind="text: res.dataValidationDialog.bottomLeft">
Bottom Left
</option>
</select>
</div>
<div id="icon-position" className="option-row">
<label>Icon Position:</label>
<select id="iconPositionOption">
<option value="Outside Left" data-bind="text: res.dataValidationDialog.outsideLeft">
Outside Left
</option>
<option value="Outside Right" data-bind="text: res.dataValidationDialog.outsideRight">
Outside Right
</option>
</select>
</div>
<div id="iconFile" className="option-row">
<input id="highlighticon" type="file" accept="image/*" onChange={e => this.changeHighlighticon(e)} />
</div>
<div className="option-row">
<input className="normal-input" id="btnSetValidator" type="button" defaultValue="Set Validator" onClick={e=>this.setValidator(e)} />
</div>
<div className="option-row">
<input className="normal-input" id="btnClearValidator" type="button" defaultValue="Clear Validator" onClick={e => this.clearValidator(e)} />
</div>
</div>
</div>;
}
initSpread(spread) {
this.spread = spread;
spread.suspendPaint();
spread.options.highlightInvalidData = true;
_getElementById("validatorTab2").style.display = 'none';
_getElementById("validatorTab3").style.display = 'none';
_getElementById("isIntTab").style.display = 'none';
_getElementById("dogear-position").style.display = 'none';
_getElementById("icon-position").style.display = 'none';
_getElementById("iconFile").style.display = 'none';
let self = this;
spread.bind(GC.Spread.Sheets.Events.EnterCell, function (e, args) {
let sheet = spread.getActiveSheet();
let activeRow = sheet.getActiveRowIndex();
let activeCol = sheet.getActiveColumnIndex();
let dataValidator = sheet.getDataValidator(activeRow, activeCol);
let validatorTypesElement = _getElementById("validatorTypes"), validatorTypes;
if (dataValidator) {
let type = dataValidator.type();
switch (type) {
case 1:
case 2:
validatorTypes = "NumberValidator";
break;
case 3:
let condition = dataValidator.condition();
if (condition && condition.formula()) {
validatorTypes = "FormulaListValidator";
} else {
validatorTypes = "ListValidator";
}
break;
case 4:
validatorTypes = "DateValidator";
break;
case 6:
validatorTypes = "TextLengthValidator";
break;
case 7:
validatorTypes = "FormulaValidator";
break;
}
validatorTypesElement.value = validatorTypes;
self.updateValidatorTab(validatorTypes);
_getElementById("validatorComparisonOperator").value = dataValidator.comparisonOperator();
_getElementById("txtValidatorValue1").value = dataValidator.value1();
_getElementById("txtValidatorValue2").value = dataValidator.value2();
_getElementById("txtValidatorValue").value = dataValidator.value1();
_getElementById("txtListValidatorValue").value = dataValidator.value1();
_getElementById("chkIsInteger").setAttribute('checked', type === 1);
_getElementById("ckbShowInputMessage").setAttribute('checked', dataValidator.showInputMessage());
_getElementById("txtInputTitle").value = dataValidator.inputTitle();
_getElementById("txtInputMessage").value = dataValidator.inputMessage();
_getElementById("chkShowError").setAttribute('checked', dataValidator.showErrorMessage());
_getElementById("chkValidatorIgnoreBlank").setAttribute('checked', dataValidator.ignoreBlank());
_getElementById("txtErrorTitle").value = dataValidator.errorTitle();
_getElementById("txtErrorMessage").value = dataValidator.errorMessage();
_getElementById("validatorErrorStyles").value = dataValidator.errorStyle();
}
});
spread.resumePaint();
}
changeHighlighticon(e) {
let self = this;
let file = e.target.files[0];
let reader = new FileReader();
if (file) {
reader.readAsDataURL(file);
reader.onloadend = function (e) {
self.imageBase64 = this.result;
};
}
}
changeHighlightType(e) {
switch (e.target.value) {
case 'circle': {
_getElementById("dogear-position").style.display = 'none';
_getElementById("icon-position").style.display = 'none';
_getElementById("iconFile").style.display = 'none';
break;
}
case 'dogear': {
_getElementById("dogear-position").style.display = '';
_getElementById("icon-position").style.display = 'none';
_getElementById("iconFile").style.display = 'none';
break;
}
case 'icon': {
_getElementById("dogear-position").style.display = 'none';
_getElementById("icon-position").style.display = '';
_getElementById("iconFile").style.display = '';
break;
}
}
}
changeValidatorTypes(e) {
let validatorTypes = e.target.value;
this.updateValidatorTab(validatorTypes);
}
updateValidatorTab(validatorTypes) {
switch (validatorTypes) {
case "DateValidator":
case "TextLengthValidator":
_getElementById("validatorTab1").style.display = 'block';
_getElementById("isIntTab").style.display = 'none';
_getElementById("validatorTab2").style.display = 'none';
_getElementById("validatorTab3").style.display = 'none';
break;
case "ListValidator":
_getElementById("validatorTab3").style.display = 'block';
_getElementById("validatorTab2").style.display = 'none';
_getElementById("validatorTab1").style.display = 'none';
break;
case "FormulaListValidator":
case "FormulaValidator":
_getElementById("validatorTab2").style.display = 'block';
_getElementById("validatorTab1").style.display = 'none';
_getElementById("validatorTab3").style.display = 'none';
break;
case "NumberValidator":
_getElementById("validatorTab1").style.display = 'block';
_getElementById("isIntTab").style.display = 'block';
_getElementById("validatorTab2").style.display = 'none';
_getElementById("validatorTab3").style.display = 'none';
break;
}
}
changeValidatorComparisonOperator(e) {
let operatorType = e.target.value;
switch (operatorType) {
case '6':
case '7':
_getElementById("txtValidatorValue2").style.display = 'block';
break;
default:
_getElementById("txtValidatorValue2").style.display = 'none';
break;
}
}
setValidator(e) {
let self = this;
let gcdv = GC.Spread.Sheets.DataValidation;
let ddv = null;
let v1 = _getElementById("txtValidatorValue1").value;
let v2 = _getElementById("txtValidatorValue2").value;
let validatorTypes = _getElementById("validatorTypes").value;
switch (validatorTypes) {
case "DateValidator":
ddv = gcdv.createDateValidator(parseInt(_getElementById("validatorComparisonOperator").value), new Date(v1), new Date(v2));
break;
case "FormulaListValidator":
ddv = gcdv.createFormulaListValidator(_getElementById("txtValidatorValue").value);
break;
case "FormulaValidator":
ddv = gcdv.createFormulaValidator(_getElementById("txtValidatorValue").value);
break;
case "ListValidator":
ddv = gcdv.createListValidator(_getElementById("txtListValidatorValue").value);
ddv.inCellDropdown(_getElementById("ckbIncellDropDown").checked);
break;
case "NumberValidator":
if (_getElementById("chkIsInteger").checked) {
ddv = gcdv.createNumberValidator(parseInt(_getElementById("validatorComparisonOperator").value),
isNaN(v1) ? v1 : parseInt(v1),
isNaN(v2) ? v2 : parseInt(v2),
true);
} else {
ddv = gcdv.createNumberValidator(parseInt(_getElementById("validatorComparisonOperator").value),
isNaN(v1) ? v1 : parseFloat(v1),
isNaN(v2) ? v2 : parseFloat(v2),
false);
}
break;
case "TextLengthValidator":
ddv = gcdv.createTextLengthValidator(parseInt(_getElementById("validatorComparisonOperator").value),
isNaN(v1) ? v1 : parseInt(v1),
isNaN(v2) ? v2 : parseInt(v2));
break;
}
if (ddv != null) {
ddv.errorMessage(_getElementById("txtErrorMessage").value);
ddv.errorStyle(parseInt(_getElementById("validatorErrorStyles").value));
ddv.errorTitle(_getElementById("txtErrorTitle").value);
ddv.showErrorMessage(_getElementById("chkShowError").checked);
ddv.ignoreBlank(_getElementById("chkValidatorIgnoreBlank").checked);
ddv.showInputMessage(_getElementById("ckbShowInputMessage").checked);
ddv.inputTitle(_getElementById("txtInputTitle").value);
ddv.inputMessage(_getElementById("txtInputMessage").value);
let highLightStyle = _getElementById("highlightType").value;
let dogearPosition = _getElementById("dogearPositionOption").value;
let iconPosition = _getElementById("iconPositionOption").value;
let highlightStyleColor = _getElementById("highlightColor").value;
if (highLightStyle === "circle") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.circle,
color: highlightStyleColor
});
} else if (highLightStyle === "dogear" && dogearPosition === "Top Left") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.topLeft
});
} else if (highLightStyle === "dogear" && dogearPosition === "Top Right") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.topRight
});
} else if (highLightStyle === "dogear" && dogearPosition === "Bottom Left") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.bottomLeft
});
} else if (highLightStyle === "dogear" && dogearPosition === "Bottom Right") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.bottomRight
});
} else if (highLightStyle === "icon" && iconPosition === "Outside Left") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.icon,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.outsideLeft,
image: self.imageBase64
});
} else if (highLightStyle === "icon" && iconPosition === "Outside Right") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.icon,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.outsideRight,
image: self.imageBase64
});
}
let ss = this.spread;
let sheet = ss.getActiveSheet();
sheet.suspendPaint();
let sels = sheet.getSelections();
for (let i = 0; i < sels.length; i++) {
let sel = this.getActualRange(sheet, sels[i]);
sheet.setDataValidator(sel.row, sel.col, sel.rowCount, sel.colCount, ddv);
}
sheet.resumePaint();
}
}
changeValidatorIgnoreBlank(e) {
let ss = this.spread;
let sheet = ss.getActiveSheet();
let sels = sheet.getSelections();
for (let i = 0; i < sels.length; i++) {
let sel = this.getActualRange(sheet, sels[i]);
for (let r = 0; r < sel.rowCount; r++) {
for (let c = 0; c < sel.colCount; c++) {
let dv = sheet.getDataValidator(sel.row + r, sel.col + c);
if (dv) {
dv.ignoreBlank(e.target.checked);
}
}
}
}
}
getActualRange(sheet, range) {
let row = range.row, rowCount = range.rowCount;
if (row === -1) {
row = 0;
rowCount = sheet.getRowCount();
}
let col = range.col, colCount = range.colCount;
if (col === -1) {
col = 0;
colCount = sheet.getColumnCount();
}
return new GC.Spread.Sheets.Range(row, col, rowCount, colCount);
}
clearValidator(e) {
let sheet = this.spread.getActiveSheet();
let sels = sheet.getSelections();
for (let i = 0; i < sels.length; i++) {
let sel = this.getActualRange(sheet, sels[i]);
sheet.setDataValidator(sel.row, sel.col, sel.rowCount, sel.colCount, null);
}
}
changeShowError(e) {
let ss = this.spread;
let checked = e.target.checked;
if (checked) {
ss.bind(GC.Spread.Sheets.Events.ValidationError, function (event, data) {
let dv = data.validator;
if (dv) {
alert(dv.errorMessage());
}
});
} else {
ss.unbind(GC.Spread.Sheets.Events.ValidationError);
}
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 5px;
}
.normal-input {
display: block;
padding: 4px 6px;
box-sizing: border-box;
width: 100%;
}
select {
display: block;
padding: 4px 6px;
box-sizing: border-box;
width: 100%;
}
input[type = checkbox] {
display: inline-block;
width: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

You can customize the validator’s title, input message, error message, and so on. With these settings you will know what data can or should be entered in a cell, and when the data is invalid you will get a message.
When you use the validator object, you can set its properties. For example:
When you input invalid data, the control will trigger the ValidationError event. For example:
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbook-initialized="initSpread">
<gc-worksheet></gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<p>
Select a cell or range of cells in the sheet then use the options below to create a data validator for
that cell(s). You can also set the input message that displays when the user tries to edit the cell(s)
as well as the error message that shows if the input does not fit the conditions.
</p>
<div class="option-row">
<select id="validatorTypes" @change="changeValidatorTypes">
<option value="DateValidator" selected>DateValidator</option>
<option value="FormulaListValidator">FormulaListValidator</option>
<option value="FormulaValidator">FormulaValidator</option>
<option value="ListValidator">ListValidator</option>
<option value="NumberValidator">NumberValidator</option>
<option value="TextLengthValidator">TextLengthValidator</option>
</select>
</div>
<div id="validatorTab1">
<div class="option-row">
<select id="validatorComparisonOperator" @change="changeValidatorComparisonOperator">
<option value="6" selected>Between</option>
<option value="7">NotBetween</option>
<option value="0">EqualTo</option>
<option value="1">NotEqualTo</option>
<option value="2">GreaterThan</option>
<option value="4">LessThan</option>
<option value="3">GreaterThanOrEqualTo</option>
<option value="5">LessThanOrEqualTo</option>
</select>
</div>
<div class="option-row">
<input class="normal-input" id="txtValidatorValue1" type="text" placeholder="Value1" />
</div>
<div class="option-row">
<input class="normal-input" id="txtValidatorValue2" type="text" placeholder="Value2" />
</div>
<div class="option-row" id="isIntTab">
<input class="normal-input" id="chkIsInteger" type="checkbox" /><label for="chkIsInteger">Is
Integer</label>
</div>
</div>
<div class="option-row" id="validatorTab2">
<input class="normal-input" type="text" id="txtValidatorValue" placeholder="Value1" />
</div>
<div class="option-row" id="validatorTab3">
<input class="normal-input" type="text" id="txtListValidatorValue" placeholder="(eg:1,2,3,4,5)" />
<input class="normal-input" type="checkbox" id="ckbIncellDropDown" checked="checked" />
<label for="ckbIncellDropDown">Show In-Cell DropDown</label>
</div>
<div class="option-row">
<input class="normal-input" type="checkbox" checked="checked" id="ckbShowInputMessage" />
<label for="ckbShowInputMessage">Show InputMessage</label>
</div>
<div class="option-row">
<label>Title:</label>
<input class="normal-input" type="text" id="txtInputTitle" placeholder="Title" />
</div>
<div class="option-row">
<label>Input Message:</label>
<input class="normal-input" type="text" id="txtInputMessage" placeholder="Input Message" />
</div>
<div class="option-row">
<input class="normal-input" id="chkShowError" type="checkbox" @change="changeShowError" />
<label for="chkShowError">ShowErrorMessage</label>
</div>
<div class="option-row">
<input class="normal-input" id="chkValidatorIgnoreBlank" type="checkbox"
@change="changeValidatorIgnoreBlank" />
<label for="chkValidatorIgnoreBlank">IgnoreBlank</label>
</div>
<div class="option-row">
<input class="normal-input" id="txtErrorTitle" type="text" placeholder="ErrorTitle" />
</div>
<div class="option-row">
<input class="normal-input" id="txtErrorMessage" type="text" placeholder="ErrorMessage" />
</div>
<div class="option-row">
<select id="validatorErrorStyles">
<option value="0" selected>Stop</option>
<option value="1">Warning</option>
<option value="2">Information</option>
</select>
</div>
<div class="option-row">
<label>Custom HighlightStyle:</label>
<select id="highlightType" @change="changeHighlightType">
<option selected="selected" value="circle" data-bind="text: res.dataValidationDialog.circle">
Circle
</option>
<option value="dogear" data-bind="text: res.dataValidationDialog.dogear">
Dogear
</option>
<option value="icon" data-bind="text: res.dataValidationDialog.icon">
Icon
</option>
</select>
</div>
<div class="option-row">
<input class="normal-input" id="highlightColor" type="text" placeholder="HighlightColor" />
</div>
<div id="dogear-position" class="option-row">
<label>Dogear Position:</label>
<select id="dogearPositionOption">
<option value="Top Left" data-bind="text: res.dataValidationDialog.topLeft">
Top Left
</option>
<option value="Top Right" data-bind="text: res.dataValidationDialog.topRight">
Top Right
</option>
<option value="Bottom Right" data-bind="text: res.dataValidationDialog.bottomRight">
Bottom Right
</option>
<option value="Bottom Left" data-bind="text: res.dataValidationDialog.bottomLeft">
Bottom Left
</option>
</select>
</div>
<div id="icon-position" class="option-row">
<label>Icon Position:</label>
<select id="iconPositionOption">
<option value="Outside Left" data-bind="text: res.dataValidationDialog.outsideLeft">
Outside Left
</option>
<option value="Outside Right" data-bind="text: res.dataValidationDialog.outsideRight">
Outside Right
</option>
</select>
</div>
<div id="iconFile" class="option-row">
<input id="highlighticon" type="file" accept="image/*" @change="changeHighlighticon">
</div>
<div class="option-row">
<input class="normal-input" id="btnSetValidator" type="button" value="Set Validator"
@click="setValidator" />
</div>
<div class="option-row">
<input class="normal-input" id="btnClearValidator" type="button" value="Clear Validator"
@click="clearValidator" />
</div>
</div>
</div>
</template>
<script setup>
import { ref } from 'vue';
import '@mescius/spread-sheets-vue';
import GC from '@mescius/spread-sheets';
const spread = ref(null);
const imageBase64 = ref('');
const initSpread = (spreadInstance) => {
spread.value = spreadInstance;
spread.value.suspendPaint();
spread.value.options.highlightInvalidData = true;
document.getElementById("validatorTab2").style.display = 'none';
document.getElementById("validatorTab3").style.display = 'none';
document.getElementById("isIntTab").style.display = 'none';
document.getElementById("dogear-position").style.display = 'none';
document.getElementById("icon-position").style.display = 'none';
document.getElementById("iconFile").style.display = 'none';
spread.value.bind(GC.Spread.Sheets.Events.EnterCell, (e, args) => {
const sheet = spread.value.getActiveSheet();
const activeRow = sheet.getActiveRowIndex();
const activeCol = sheet.getActiveColumnIndex();
const dataValidator = sheet.getDataValidator(activeRow, activeCol);
const validatorTypesElement = document.getElementById("validatorTypes");
let validatorTypes;
if (dataValidator) {
const type = dataValidator.type();
switch (type) {
case 1:
case 2:
validatorTypes = "NumberValidator";
break;
case 3:
const condition = dataValidator.condition();
if (condition && condition.formula()) {
validatorTypes = "FormulaListValidator";
} else {
validatorTypes = "ListValidator";
}
break;
case 4:
validatorTypes = "DateValidator";
break;
case 6:
validatorTypes = "TextLengthValidator";
break;
case 7:
validatorTypes = "FormulaValidator";
break;
}
validatorTypesElement.value = validatorTypes;
updateValidatorTab(validatorTypes);
document.getElementById("validatorComparisonOperator").value = dataValidator.comparisonOperator();
document.getElementById("txtValidatorValue1").value = dataValidator.value1();
document.getElementById("txtValidatorValue2").value = dataValidator.value2();
document.getElementById("txtValidatorValue").value = dataValidator.value1();
document.getElementById("txtListValidatorValue").value = dataValidator.value1();
document.getElementById("chkIsInteger").setAttribute('checked', type === 1);
document.getElementById("ckbShowInputMessage").setAttribute('checked', dataValidator.showInputMessage());
document.getElementById("txtInputTitle").value = dataValidator.inputTitle();
document.getElementById("txtInputMessage").value = dataValidator.inputMessage();
document.getElementById("chkShowError").setAttribute('checked', dataValidator.showErrorMessage());
document.getElementById("chkValidatorIgnoreBlank").setAttribute('checked', dataValidator.ignoreBlank());
document.getElementById("txtErrorTitle").value = dataValidator.errorTitle();
document.getElementById("txtErrorMessage").value = dataValidator.errorMessage();
document.getElementById("validatorErrorStyles").value = dataValidator.errorStyle();
}
});
spread.value.resumePaint();
};
const changeHighlighticon = (e) => {
const file = e.target.files[0];
const reader = new FileReader();
if (file) {
reader.readAsDataURL(file);
reader.onloadend = () => {
imageBase64.value = reader.result;
};
}
};
const changeHighlightType = (e) => {
switch (e.target.value) {
case 'circle':
document.getElementById("dogear-position").style.display = 'none';
document.getElementById("icon-position").style.display = 'none';
document.getElementById("iconFile").style.display = 'none';
break;
case 'dogear':
document.getElementById("dogear-position").style.display = '';
document.getElementById("icon-position").style.display = 'none';
document.getElementById("iconFile").style.display = 'none';
break;
case 'icon':
document.getElementById("dogear-position").style.display = 'none';
document.getElementById("icon-position").style.display = '';
document.getElementById("iconFile").style.display = '';
break;
}
};
const changeValidatorTypes = (e) => {
const validatorTypes = e.target.value;
updateValidatorTab(validatorTypes);
};
const updateValidatorTab = (validatorTypes) => {
switch (validatorTypes) {
case "DateValidator":
case "TextLengthValidator":
document.getElementById("validatorTab1").style.display = 'block';
document.getElementById("isIntTab").style.display = 'none';
document.getElementById("validatorTab2").style.display = 'none';
document.getElementById("validatorTab3").style.display = 'none';
break;
case "ListValidator":
document.getElementById("validatorTab3").style.display = 'block';
document.getElementById("validatorTab2").style.display = 'none';
document.getElementById("validatorTab1").style.display = 'none';
break;
case "FormulaListValidator":
case "FormulaValidator":
document.getElementById("validatorTab2").style.display = 'block';
document.getElementById("validatorTab1").style.display = 'none';
document.getElementById("validatorTab3").style.display = 'none';
break;
case "NumberValidator":
document.getElementById("validatorTab1").style.display = 'block';
document.getElementById("isIntTab").style.display = 'block';
document.getElementById("validatorTab2").style.display = 'none';
document.getElementById("validatorTab3").style.display = 'none';
break;
}
};
const changeValidatorComparisonOperator = (e) => {
const operatorType = e.target.value;
switch (operatorType) {
case '6':
case '7':
document.getElementById("txtValidatorValue2").style.display = 'block';
break;
default:
document.getElementById("txtValidatorValue2").style.display = 'none';
break;
}
};
const setValidator = (e) => {
const gcdv = GC.Spread.Sheets.DataValidation;
let ddv = null;
const v1 = document.getElementById("txtValidatorValue1").value;
const v2 = document.getElementById("txtValidatorValue2").value;
const validatorTypes = document.getElementById("validatorTypes").value;
switch (validatorTypes) {
case "DateValidator":
ddv = gcdv.createDateValidator(parseInt(document.getElementById("validatorComparisonOperator").value), new Date(v1), new Date(v2));
break;
case "FormulaListValidator":
ddv = gcdv.createFormulaListValidator(document.getElementById("txtValidatorValue").value);
break;
case "FormulaValidator":
ddv = gcdv.createFormulaValidator(document.getElementById("txtValidatorValue").value);
break;
case "ListValidator":
ddv = gcdv.createListValidator(document.getElementById("txtListValidatorValue").value);
ddv.inCellDropdown(document.getElementById("ckbIncellDropDown").checked);
break;
case "NumberValidator":
if (document.getElementById("chkIsInteger").checked) {
ddv = gcdv.createNumberValidator(parseInt(_getElementById("validatorComparisonOperator").value),
isNaN(v1) ? v1 : parseInt(v1),
isNaN(v2) ? v2 : parseInt(v2),
true);
} else {
ddv = gcdv.createNumberValidator(parseInt(_getElementById("validatorComparisonOperator").value),
isNaN(v1) ? v1 : parseFloat(v1),
isNaN(v2) ? v2 : parseFloat(v2),
false);
}
break;
case "TextLengthValidator":
ddv = gcdv.createTextLengthValidator(parseInt(_getElementById("validatorComparisonOperator").value),
isNaN(v1) ? v1 : parseInt(v1),
isNaN(v2) ? v2 : parseInt(v2));
break;
}
if (ddv != null) {
ddv.errorMessage(_getElementById("txtErrorMessage").value);
ddv.errorStyle(parseInt(_getElementById("validatorErrorStyles").value));
ddv.errorTitle(_getElementById("txtErrorTitle").value);
ddv.showErrorMessage(_getElementById("chkShowError").checked);
ddv.ignoreBlank(_getElementById("chkValidatorIgnoreBlank").checked);
ddv.showInputMessage(_getElementById("ckbShowInputMessage").checked);
ddv.inputTitle(_getElementById("txtInputTitle").value);
ddv.inputMessage(_getElementById("txtInputMessage").value);
let highLightStyle = _getElementById("highlightType").value;
let dogearPosition = _getElementById("dogearPositionOption").value;
let iconPosition = _getElementById("iconPositionOption").value;
let highlightStyleColor = _getElementById("highlightColor").value;
if (highLightStyle === "circle") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.circle,
color: highlightStyleColor
});
} else if (highLightStyle === "dogear" && dogearPosition === "Top Left") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.topLeft
});
} else if (highLightStyle === "dogear" && dogearPosition === "Top Right") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.topRight
});
} else if (highLightStyle === "dogear" && dogearPosition === "Bottom Left") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.bottomLeft
});
} else if (highLightStyle === "dogear" && dogearPosition === "Bottom Right") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.bottomRight
});
} else if (highLightStyle === "icon" && iconPosition === "Outside Left") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.icon,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.outsideLeft,
image: self.imageBase64
});
} else if (highLightStyle === "icon" && iconPosition === "Outside Right") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.icon,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.outsideRight,
image: self.imageBase64
});
}
let ss = spread.value;
let sheet = ss.getActiveSheet();
sheet.suspendPaint();
let sels = sheet.getSelections();
for (let i = 0; i < sels.length; i++) {
let sel = getActualRange(sheet, sels[i]);
sheet.setDataValidator(sel.row, sel.col, sel.rowCount, sel.colCount, ddv);
}
sheet.resumePaint();
}
};
const clearValidator = (e) => {
const sheet = spread.value.getActiveSheet();
let sels = sheet.getSelections();
for (let i = 0; i < sels.length; i++) {
let sel = getActualRange(sheet, sels[i]);
sheet.setDataValidator(sel.row, sel.col, sel.rowCount, sel.colCount, null);
}
};
const changeShowError = (e) => {
const ss = spread.value;
let checked = e.target.checked;
if (checked) {
ss.bind(GC.Spread.Sheets.Events.ValidationError, function (event, data) {
let dv = data.validator;
if (dv) {
alert(dv.errorMessage());
}
});
} else {
ss.unbind(GC.Spread.Sheets.Events.ValidationError);
}
};
const changeValidatorIgnoreBlank = (e) => {
const sheet = spread.value.getActiveSheet();
let sels = sheet.getSelections();
for (let i = 0; i < sels.length; i++) {
let sel = getActualRange(sheet, sels[i]);
for (let r = 0; r < sel.rowCount; r++) {
for (let c = 0; c < sel.colCount; c++) {
let dv = sheet.getDataValidator(sel.row + r, sel.col + c);
if (dv) {
dv.ignoreBlank(e.target.checked);
}
}
}
}
};
const getActualRange = (sheet, range) => {
let row = range.row,
rowCount = range.rowCount;
if (row === -1) {
row = 0;
rowCount = sheet.getRowCount();
}
let col = range.col,
colCount = range.colCount;
if (col === -1) {
col = 0;
colCount = sheet.getColumnCount();
}
return new GC.Spread.Sheets.Range(row, col, rowCount, colCount);
};
function _getElementById(id) {
return document.getElementById(id);
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 5px;
}
.normal-input {
display: block;
padding: 4px 6px;
box-sizing: border-box;
width: 100%;
}
select {
display: block;
padding: 4px 6px;
box-sizing: border-box;
width: 100%;
}
input[type=checkbox] {
display: inline-block;
width: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script src="compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

You can customize the validator’s title, input message, error message, and so on. With these settings you will know what data can or should be entered in a cell, and when the data is invalid you will get a message.
When you use the validator object, you can set its properties. For example:
When you input invalid data, the control will trigger the ValidationError event. For example:
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
imageBase64: string;
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
spread.suspendPaint();
spread.options.highlightInvalidData = true;
_getElementById("validatorTab2").style.display = 'none';
_getElementById("validatorTab3").style.display = 'none';
_getElementById("isIntTab").style.display = 'none';
_getElementById("dogear-position").style.display = 'none';
_getElementById("icon-position").style.display = 'none';
_getElementById("iconFile").style.display = 'none';
let self = this;
spread.bind(GC.Spread.Sheets.Events.EnterCell, function (e: any, args: any) {
let sheet = spread.getActiveSheet();
let activeRow = sheet.getActiveRowIndex();
let activeCol = sheet.getActiveColumnIndex();
let dataValidator = sheet.getDataValidator(activeRow, activeCol);
let validatorTypesElement = _getElementById("validatorTypes"), validatorTypes;
if (dataValidator) {
let type = dataValidator.type();
switch (type) {
case 1:
case 2:
validatorTypes = "NumberValidator";
break;
case 3:
let condition = dataValidator.condition();
if (condition && condition.formula()) {
validatorTypes = "FormulaListValidator";
} else {
validatorTypes = "ListValidator";
}
break;
case 4:
validatorTypes = "DateValidator";
break;
case 6:
validatorTypes = "TextLengthValidator";
break;
case 7:
validatorTypes = "FormulaValidator";
break;
}
validatorTypesElement.value = validatorTypes;
self.updateValidatorTab(validatorTypes);
_getElementById("validatorComparisonOperator").value = dataValidator.comparisonOperator();
_getElementById("txtValidatorValue1").value = dataValidator.value1();
_getElementById("txtValidatorValue2").value = dataValidator.value2();
_getElementById("txtValidatorValue").value = dataValidator.value1();
_getElementById("txtListValidatorValue").value = dataValidator.value1();
_getElementById("chkIsInteger").setAttribute('checked', type === 1);
_getElementById("ckbShowInputMessage").setAttribute('checked', dataValidator.showInputMessage());
_getElementById("txtInputTitle").value = dataValidator.inputTitle();
_getElementById("txtInputMessage").value = dataValidator.inputMessage();
_getElementById("chkShowError").setAttribute('checked', dataValidator.showErrorMessage());
_getElementById("chkValidatorIgnoreBlank").setAttribute('checked', dataValidator.ignoreBlank());
_getElementById("txtErrorTitle").value = dataValidator.errorTitle();
_getElementById("txtErrorMessage").value = dataValidator.errorMessage();
_getElementById("validatorErrorStyles").value = dataValidator.errorStyle();
}
});
spread.resumePaint();
}
changeHighlighticon(e: any) {
let self = this;
let file = e.target.files[0];
let reader = new FileReader();
if (file) {
reader.readAsDataURL(file);
reader.onloadend = function (e) {
self.imageBase64 = <string>this.result;
};
}
}
changeHighlightType(e: any) {
switch (e.target.value) {
case 'circle': {
_getElementById("dogear-position").style.display = 'none';
_getElementById("icon-position").style.display = 'none';
_getElementById("iconFile").style.display = 'none';
break;
}
case 'dogear': {
_getElementById("dogear-position").style.display = '';
_getElementById("icon-position").style.display = 'none';
_getElementById("iconFile").style.display = 'none';
break;
}
case 'icon': {
_getElementById("dogear-position").style.display = 'none';
_getElementById("icon-position").style.display = '';
_getElementById("iconFile").style.display = '';
break;
}
}
}
changeValidatorTypes(e: any) {
let validatorTypes = e.target.value;
this.updateValidatorTab(validatorTypes);
}
updateValidatorTab(validatorTypes: string) {
switch (validatorTypes) {
case "DateValidator":
case "TextLengthValidator":
_getElementById("validatorTab1").style.display = 'block';
_getElementById("isIntTab").style.display = 'none';
_getElementById("validatorTab2").style.display = 'none';
_getElementById("validatorTab3").style.display = 'none';
break;
case "ListValidator":
_getElementById("validatorTab3").style.display = 'block';
_getElementById("validatorTab2").style.display = 'none';
_getElementById("validatorTab1").style.display = 'none';
break;
case "FormulaListValidator":
case "FormulaValidator":
_getElementById("validatorTab2").style.display = 'block';
_getElementById("validatorTab1").style.display = 'none';
_getElementById("validatorTab3").style.display = 'none';
break;
case "NumberValidator":
_getElementById("validatorTab1").style.display = 'block';
_getElementById("isIntTab").style.display = 'block';
_getElementById("validatorTab2").style.display = 'none';
_getElementById("validatorTab3").style.display = 'none';
break;
}
}
changeValidatorComparisonOperator(e: any) {
let operatorType = e.target.value;
switch (operatorType) {
case '6':
case '7':
_getElementById("txtValidatorValue2").style.display = 'block';
break;
default:
_getElementById("txtValidatorValue2").style.display = 'none';
break;
}
}
setValidator(e: any) {
let self = this;
let gcdv = GC.Spread.Sheets.DataValidation;
let ddv = null;
let v1 = _getElementById("txtValidatorValue1").value;
let v2 = _getElementById("txtValidatorValue2").value;
let validatorTypes = _getElementById("validatorTypes").value;
switch (validatorTypes) {
case "DateValidator":
ddv = gcdv.createDateValidator(parseInt(_getElementById("validatorComparisonOperator").value), new Date(v1), new Date(v2));
break;
case "FormulaListValidator":
ddv = gcdv.createFormulaListValidator(_getElementById("txtValidatorValue").value);
break;
case "FormulaValidator":
ddv = gcdv.createFormulaValidator(_getElementById("txtValidatorValue").value);
break;
case "ListValidator":
ddv = gcdv.createListValidator(_getElementById("txtListValidatorValue").value);
ddv.inCellDropdown(_getElementById("ckbIncellDropDown").checked);
break;
case "NumberValidator":
if (_getElementById("chkIsInteger").checked) {
ddv = gcdv.createNumberValidator(parseInt(_getElementById("validatorComparisonOperator").value),
isNaN(v1) ? v1 : parseInt(v1),
isNaN(v2) ? v2 : parseInt(v2),
true);
} else {
ddv = gcdv.createNumberValidator(parseInt(_getElementById("validatorComparisonOperator").value),
isNaN(v1) ? v1 : parseFloat(v1),
isNaN(v2) ? v2 : parseFloat(v2),
false);
}
break;
case "TextLengthValidator":
ddv = gcdv.createTextLengthValidator(parseInt(_getElementById("validatorComparisonOperator").value),
isNaN(v1) ? v1 : parseInt(v1),
isNaN(v2) ? v2 : parseInt(v2));
break;
}
if (ddv != null) {
ddv.errorMessage(_getElementById("txtErrorMessage").value);
ddv.errorStyle(parseInt(_getElementById("validatorErrorStyles").value));
ddv.errorTitle(_getElementById("txtErrorTitle").value);
ddv.showErrorMessage(_getElementById("chkShowError").checked);
ddv.ignoreBlank(_getElementById("chkValidatorIgnoreBlank").checked);
ddv.showInputMessage(_getElementById("ckbShowInputMessage").checked);
ddv.inputTitle(_getElementById("txtInputTitle").value);
ddv.inputMessage(_getElementById("txtInputMessage").value);
let highLightStyle = _getElementById("highlightType").value;
let dogearPosition = _getElementById("dogearPositionOption").value;
let iconPosition = _getElementById("iconPositionOption").value;
let highlightStyleColor = _getElementById("highlightColor").value;
if (highLightStyle === "circle") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.circle,
color: highlightStyleColor
});
} else if (highLightStyle === "dogear" && dogearPosition === "Top Left") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.topLeft
});
} else if (highLightStyle === "dogear" && dogearPosition === "Top Right") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.topRight
});
} else if (highLightStyle === "dogear" && dogearPosition === "Bottom Left") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.bottomLeft
});
} else if (highLightStyle === "dogear" && dogearPosition === "Bottom Right") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.dogEar,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.bottomRight
});
} else if (highLightStyle === "icon" && iconPosition === "Outside Left") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.icon,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.outsideLeft,
image: self.imageBase64
});
} else if (highLightStyle === "icon" && iconPosition === "Outside Right") {
ddv.highlightStyle({
type: GC.Spread.Sheets.DataValidation.HighlightType.icon,
color: highlightStyleColor,
position: GC.Spread.Sheets.DataValidation.HighlightPosition.outsideRight,
image: self.imageBase64
});
}
let ss = this.spread;
let sheet = ss.getActiveSheet();
sheet.suspendPaint();
let sels = sheet.getSelections();
for (let i = 0; i < sels.length; i++) {
let sel = this.getActualRange(sheet, sels[i]);
sheet.setDataValidator(sel.row, sel.col, sel.rowCount, sel.colCount, ddv);
}
sheet.resumePaint();
}
}
changeValidatorIgnoreBlank(e: any) {
let ss = this.spread;
let sheet = ss.getActiveSheet();
let sels = sheet.getSelections();
for (let i = 0; i < sels.length; i++) {
let sel = this.getActualRange(sheet, sels[i]);
for (let r = 0; r < sel.rowCount; r++) {
for (let c = 0; c < sel.colCount; c++) {
let dv = sheet.getDataValidator(sel.row + r, sel.col + c);
if (dv) {
dv.ignoreBlank(e.target.checked);
}
}
}
}
}
getActualRange(sheet: GC.Spread.Sheets.Worksheet, range: GC.Spread.Sheets.Range) {
let row = range.row, rowCount = range.rowCount;
if (row === -1) {
row = 0;
rowCount = sheet.getRowCount();
}
let col = range.col, colCount = range.colCount;
if (col === -1) {
col = 0;
colCount = sheet.getColumnCount();
}
return new GC.Spread.Sheets.Range(row, col, rowCount, colCount);
}
clearValidator(e: any) {
let sheet = this.spread.getActiveSheet();
let sels = sheet.getSelections();
for (let i = 0; i < sels.length; i++) {
let sel = this.getActualRange(sheet, sels[i]);
sheet.setDataValidator(sel.row, sel.col, sel.rowCount, sel.colCount, null);
}
}
changeShowError(e: any) {
let ss = this.spread;
let checked = e.target.checked;
if (checked) {
ss.bind(GC.Spread.Sheets.Events.ValidationError, function (event: any, data: any) {
let dv = data.validator;
if (dv) {
alert(dv.errorMessage());
}
});
} else {
ss.unbind(GC.Spread.Sheets.Events.ValidationError);
}
}
}
function _getElementById(id: string): any {
return document.getElementById(id);
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<p>
Select a cell or range of cells in the sheet then use the options below to create a data validator for that
cell(s). You can also set the input message that displays when the user tries to edit the cell(s) as well as
the error message that shows if the input does not fit the conditions.
</p>
<div class="option-row">
<select id="validatorTypes" (change)="changeValidatorTypes($event)">
<option value="DateValidator" selected>DateValidator</option>
<option value="FormulaListValidator">FormulaListValidator</option>
<option value="FormulaValidator">FormulaValidator</option>
<option value="ListValidator">ListValidator</option>
<option value="NumberValidator">NumberValidator</option>
<option value="TextLengthValidator">TextLengthValidator</option>
</select>
</div>
<div id="validatorTab1">
<div class="option-row">
<select id="validatorComparisonOperator" (change)="changeValidatorComparisonOperator($event)">
<option value="6" selected>Between</option>
<option value="7">NotBetween</option>
<option value="0">EqualTo</option>
<option value="1">NotEqualTo</option>
<option value="2">GreaterThan</option>
<option value="4">LessThan</option>
<option value="3">GreaterThanOrEqualTo</option>
<option value="5">LessThanOrEqualTo</option>
</select>
</div>
<div class="option-row">
<input class="normal-input" id="txtValidatorValue1" type="text" placeholder="Value1" />
</div>
<div class="option-row">
<input class="normal-input" id="txtValidatorValue2" type="text" placeholder="Value2" />
</div>
<div class="option-row" id="isIntTab">
<input class="normal-input" id="chkIsInteger" type="checkbox" /><label for="chkIsInteger">Is
Integer</label>
</div>
</div>
<div class="option-row" id="validatorTab2">
<input class="normal-input" type="text" id="txtValidatorValue" placeholder="Value1" />
</div>
<div class="option-row" id="validatorTab3">
<input class="normal-input" type="text" id="txtListValidatorValue" placeholder="(eg:1,2,3,4,5)" />
<input class="normal-input" type="checkbox" id="ckbIncellDropDown" checked="checked" />
<label for="ckbIncellDropDown">Show In-Cell DropDown</label>
</div>
<div class="option-row">
<input class="normal-input" type="checkbox" checked="checked" id="ckbShowInputMessage" />
<label for="ckbShowInputMessage">Show InputMessage</label>
</div>
<div class="option-row">
<label>Title:</label>
<input class="normal-input" type="text" id="txtInputTitle" placeholder="Title" />
</div>
<div class="option-row">
<label>Input Message:</label>
<input class="normal-input" type="text" id="txtInputMessage" placeholder="Input Message" />
</div>
<div class="option-row">
<input class="normal-input" id="chkShowError" type="checkbox" (change)="changeShowError($event)" />
<label for="chkShowError">ShowErrorMessage</label>
</div>
<div class="option-row">
<input class="normal-input" id="chkValidatorIgnoreBlank" type="checkbox"
(change)="changeValidatorIgnoreBlank($event)" />
<label for="chkValidatorIgnoreBlank">IgnoreBlank</label>
</div>
<div class="option-row">
<input class="normal-input" id="txtErrorTitle" type="text" placeholder="ErrorTitle" />
</div>
<div class="option-row">
<input class="normal-input" id="txtErrorMessage" type="text" placeholder="ErrorMessage" />
</div>
<div class="option-row">
<select id="validatorErrorStyles">
<option value="0" selected>Stop</option>
<option value="1">Warning</option>
<option value="2">Information</option>
</select>
</div>
<div class="option-row">
<label>Custom HighlightStyle:</label>
<select id="highlightType" (change)="changeHighlightType($event)">
<option selected="selected" value="circle" data-bind="text: res.dataValidationDialog.circle">
Circle
</option>
<option value="dogear" data-bind="text: res.dataValidationDialog.dogear">
Dogear
</option>
<option value="icon" data-bind="text: res.dataValidationDialog.icon">
Icon
</option>
</select>
</div>
<div class="option-row">
<input class="normal-input" id="highlightColor" type="text" placeholder="HighlightColor" />
</div>
<div id="dogear-position" class="option-row">
<label>Dogear Position:</label>
<select id="dogearPositionOption">
<option value="Top Left" data-bind="text: res.dataValidationDialog.topLeft">
Top Left
</option>
<option value="Top Right" data-bind="text: res.dataValidationDialog.topRight">
Top Right
</option>
<option value="Bottom Right" data-bind="text: res.dataValidationDialog.bottomRight">
Bottom Right
</option>
<option value="Bottom Left" data-bind="text: res.dataValidationDialog.bottomLeft">
Bottom Left
</option>
</select>
</div>
<div id="icon-position" class="option-row">
<label>Icon Position:</label>
<select id="iconPositionOption">
<option value="Outside Left" data-bind="text: res.dataValidationDialog.outsideLeft">
Outside Left
</option>
<option value="Outside Right" data-bind="text: res.dataValidationDialog.outsideRight">
Outside Right
</option>
</select>
</div>
<div id="iconFile" class="option-row">
<input id="highlighticon" type="file" accept="image/*" (change)="changeHighlighticon($event)">
</div>
<div class="option-row">
<input class="normal-input" id="btnSetValidator" type="button" value="Set Validator"
(click)="setValidator($event)" />
</div>
<div class="option-row">
<input class="normal-input" id="btnClearValidator" type="button" value="Clear Validator"
(click)="clearValidator($event)" />
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 5px;
}
.normal-input {
display: block;
padding: 4px 6px;
box-sizing: border-box;
width: 100%;
}
select {
display: block;
padding: 4px 6px;
box-sizing: border-box;
width: 100%;
}
input[type = checkbox] {
display: inline-block;
width: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);